﻿Imports System
Imports System.IO

Public Class Form1

    Private Declare Function SystemParametersInfo Lib "user32" Alias "SystemParametersInfoA" (ByVal uAction As Integer, ByVal uParam As Integer, ByVal lpvParam As String, ByVal fuWinIni As Integer) As Integer
    Const SPI_SETDESKWALLPAPER = 20
    Const SPIF_UPDATEINIFILE = &H1
    
    Private Enum DesktopStyle As Integer
        Replace = 0
        Tiled = 1
        Centred = 2
        Streched = 4
        None = 5
    End Enum

    Dim percWallpaper As New ArrayList
    Dim riga As Byte = 0
    Dim z As Byte = 0
    Dim tipIns As Byte
    Dim utenteEsperto As Boolean = False
    Dim chiave As Microsoft.Win32.RegistryKey

    Private Sub WallpaperChange(ByRef Wallpaper As Image, ByVal fileName As String, ByVal Style As Byte)
        Dim WallpaperStyle As Object = Nothing
        Dim TileWallpaper As Object = Nothing

        If fileName = "" And Wallpaper IsNot Nothing Then
            fileName = IO.Path.Combine(My.Computer.FileSystem.SpecialDirectories.CurrentUserApplicationData, "Temp.bmp")
            Wallpaper.Save(fileName, System.Drawing.Imaging.ImageFormat.Bmp)
        End If

        If Style = DesktopStyle.Replace Then
            WallpaperStyle = chiave.GetValue("WallpaperStyle")
            TileWallpaper = chiave.GetValue("TileWallpaper")
        End If

        Select Case Style
            Case DesktopStyle.Centred
                WallpaperStyle = "1"
                TileWallpaper = "0"
            Case DesktopStyle.Streched
                WallpaperStyle = "2"
                TileWallpaper = "0"
            Case DesktopStyle.Tiled
                WallpaperStyle = "1"
                TileWallpaper = "1"
            Case DesktopStyle.None
                fileName = ""
        End Select

        chiave = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Control Panel\Desktop", True)
        chiave.SetValue("WallpaperStyle", WallpaperStyle)
        chiave.SetValue("TileWallpaper", TileWallpaper)
        chiave.Close()
        SystemParametersInfo(SPI_SETDESKWALLPAPER, 0, fileName, SPIF_UPDATEINIFILE)
    End Sub

    Private Sub LoadWallpaperChange()
        Dim fileWallpaper As New IO.StreamReader(Application.StartupPath & "\data.dat")
        Dim riga As String = ""

        Do
            riga = fileWallpaper.ReadLine()
            If Not riga Is Nothing Then
                percWallpaper.Add(riga)
            End If
        Loop Until riga Is Nothing

        fileWallpaper.Close()
        Dim chiave As Microsoft.Win32.RegistryKey
        chiave = Microsoft.Win32.Registry.CurrentUser.OpenSubKey("Software\Wallpaper Manager")

        Select Case chiave.GetValue("Mode")
            Case 1
                tipIns = DesktopStyle.Centred
                RadioButton1.Checked = True
            Case 2
                tipIns = DesktopStyle.Tiled
                RadioButton2.Checked = True
            Case 3
                tipIns = DesktopStyle.Streched
                RadioButton3.Checked = True
        End Select

        TextBox1.Text = chiave.GetValue("Time")

        If chiave.GetValue("Autostart") = 1 Then
            CheckBox1.CheckState = CheckState.Checked
            CheckBox1.Text = "Attivo"
        Else
            CheckBox1.CheckState = CheckState.Unchecked
            CheckBox1.Text = "Disattivato"
        End If

        chiave.Close()
        RadioButton1.Enabled = False
        RadioButton2.Enabled = False
        RadioButton3.Enabled = False
        Timer1.Interval = TextBox1.Text * 60000
        Timer1.Start()
        Button2.Text = "Interrompi"
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click
        If Button2.Text = "Avvia" Then
            If IO.File.Exists(Application.StartupPath & "\data.dat") = True Then
                LoadWallpaperChange()
            Else
                MessageBox.Show("Il file 'data.dat' non è presente nella directory di avvio del programma!. Assicurati di aver premuto su 'Salva...'.", "Errore", MessageBoxButtons.OK, MessageBoxIcon.Error)
            End If
        Else
            RadioButton1.Enabled = True
            RadioButton2.Enabled = True
            RadioButton3.Enabled = True
            Timer1.Stop()
            Button2.Text = "Avvia"
        End If
    End Sub

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
        If OpenFileDialog1.ShowDialog = Windows.Forms.DialogResult.OK Then
            PictureBox1.BackgroundImage = Image.FromFile(OpenFileDialog1.FileName)
            RichTextBox1.AppendText(OpenFileDialog1.FileName)
            RichTextBox1.AppendText(vbNewLine)
            MessageBox.Show("Wallpaper inserito nell'archivio con successo!", "Operazione effettuata", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        Dim fileWallpaper As New IO.StreamWriter(Application.StartupPath & "\data.dat")
        fileWallpaper.Write(RichTextBox1.Text)
        fileWallpaper.Close()
        MessageBox.Show("Archivio aggiornato con successo!.", "Operazione effettuata", MessageBoxButtons.OK, MessageBoxIcon.Information)
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Control Panel\Desktop")
        PictureBox1.BackgroundImage = Image.FromFile(chiave.GetValue("WallPaper"))

        If IO.File.Exists(Application.StartupPath & "\data.dat") = True Then
            Dim fileWallpaper As New IO.StreamReader(Application.StartupPath & "\data.dat")
            RichTextBox1.Text = fileWallpaper.ReadToEnd()
            fileWallpaper.Close()
            LoadWallpaperChange()
            Me.WindowState = FormWindowState.Minimized
            Me.ShowInTaskbar = False
        Else
            RadioButton2.Checked = True
            TextBox1.Text = "5"
            CheckBox1.CheckState = CheckState.Checked
            MessageBox.Show("Questo è il tuo primo utilizzo di Wallpaper Manager, ora procedi a inserire i vari Wallpaper nell'archivio, cliccando semplicemente su 'Inserisci...' e al termine dell'operazione su 'Salva...'.", "Benvenuto", MessageBoxButtons.OK, MessageBoxIcon.Information)
        End If
    End Sub

    Private Sub Timer1_Tick(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Timer1.Tick
        If z < percWallpaper.Count Then
            PictureBox1.BackgroundImage = Image.FromFile(percWallpaper(z))
            WallpaperChange(PictureBox1.Image, percWallpaper(z), tipIns)
            z += 1
            If z = percWallpaper.Count Then
                z = 0
            End If
        End If
    End Sub

    Private Sub RichTextBox1_KeyDown(ByVal sender As System.Object, ByVal e As System.Windows.Forms.KeyEventArgs) Handles RichTextBox1.KeyDown
        If utenteEsperto = False Then
            If MessageBox.Show("Modificando questa Textbox potresti rendere inutilizzabile il programma!. Vuoi continuare???", "Conferma", MessageBoxButtons.YesNo, MessageBoxIcon.Question) = Windows.Forms.DialogResult.Yes Then
                utenteEsperto = True
            Else
                RichTextBox1.ClearUndo()
            End If
       End If
    End Sub

    Private Sub CheckBox1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CheckBox1.CheckedChanged
        If Me.CheckBox1.CheckState = CheckState.Checked Then
            CheckBox1.Text = "Attivo"
            chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
            chiave.SetValue("Autostart", "1")
            chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Microsoft\Windows\CurrentVersion\Run")
            chiave.SetValue("Wallpaper Manager", Application.StartupPath & "\Wallpaper Manager.exe")
            chiave.Close()
        End If

        If Me.CheckBox1.CheckState = CheckState.Unchecked Then
            CheckBox1.Text = "Disattivato"
            chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
            chiave.SetValue("Autostart", "0")
            chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Microsoft\Windows\CurrentVersion\Run")
            chiave.DeleteValue("Wallpaper Manager")
            chiave.Close()
        End If
    End Sub

    Private Sub RadioButton1_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton1.CheckedChanged
        chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
        chiave.SetValue("Mode", "1")
        chiave.Close()
    End Sub

    Private Sub RadioButton2_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton2.CheckedChanged
        chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
        chiave.SetValue("Mode", "2")
        chiave.Close()
    End Sub

    Private Sub RadioButton3_CheckedChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles RadioButton3.CheckedChanged
        chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
        chiave.SetValue("Mode", "3")
        chiave.Close()
    End Sub

    Private Sub TextBox1_TextChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles TextBox1.TextChanged
        If String.IsNullOrEmpty(TextBox1.Text) = False Then
            chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
            chiave.SetValue("Time", TextBox1.Text)
            chiave.Close()
        End If
    End Sub

    Private Sub Button4_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button4.Click
        If IO.File.Exists(Application.StartupPath & "\data.dat") = True And Button2.Text = "Avvia" Then
            My.Computer.FileSystem.DeleteFile(Application.StartupPath & "\data.dat")
            chiave = Microsoft.Win32.Registry.CurrentUser.CreateSubKey("Software\Wallpaper Manager")
            chiave.SetValue("Mode", "2")
            chiave.SetValue("Time", "5")
            chiave.SetValue("Autostart", "1")
            chiave.Close()
            RichTextBox1.Clear()
            RadioButton2.Checked = True
            TextBox1.Text = "5"
        End If
    End Sub

    Private Sub MostraNascondiToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MostraNascondiToolStripMenuItem.Click
        If Me.WindowState = FormWindowState.Minimized Then
            Me.WindowState = FormWindowState.Normal
            Me.ShowInTaskbar = True
            Me.Show()
        Else
            Me.WindowState = FormWindowState.Minimized
            Me.ShowInTaskbar = False
        End If
    End Sub

    Private Sub NotifyIcon1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles NotifyIcon1.Click
        If Me.WindowState = FormWindowState.Minimized Then
            Me.WindowState = FormWindowState.Normal
            Me.ShowInTaskbar = True
            Me.Show()
        Else
            Me.WindowState = FormWindowState.Minimized
            Me.ShowInTaskbar = False
        End If
    End Sub

    Private Sub InfoSuToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles InfoSuToolStripMenuItem.Click
        frmInfoSu.ShowDialog()
    End Sub

    Private Sub EsciToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles EsciToolStripMenuItem.Click
        Me.Close()
    End Sub
End Class
